import EvoluiSaldoRepository from "../Repositories/EvoluiSaldoRepository.js";

 // function that updates the balance of the consumer's family, to check for wrong balances
const EvoluiSaldoFunction = async function (params, connectionKey) {
    if (params.CDCLIENTE && params.CDCONSUMIDOR && params.DTMOVEXTCONS && params.NRORG) {
        console.log('iniciando verificação de saldo')
        const allFamilies = await EvoluiSaldoRepository.getSaldoAllFamilies(params, false, connectionKey) 

        for (let i = 0; i < allFamilies.length; i++) {
            const family = allFamilies[i]
            family.DTMOVEXTCONS = params.DTMOVEXTCONS

            let forFamilie = await EvoluiSaldoRepository.getSaldoForFamilie(family, false, connectionKey)
            for (let j = 0; j < forFamilie.length; j++) {
                const key = j

                if (key === 0) { // caso for o primeiro movimento do consumidor da familia
                    forFamilie[key] = await CalculoSaldo(forFamilie[key], family)
                }

                await EvoluiSaldoRepository.AtualizaMovimetacaoExtrato(forFamilie[key], key, false, connectionKey) 

                const SALDOFINAL = forFamilie[key].SALDOFINAL
                if (forFamilie[key + 1]) {
                    forFamilie[key + 1].SALDOFINAL = SALDOFINAL
                    forFamilie[key + 1] = await CalculoSaldoFinal(forFamilie[key + 1]) 
                }

                family.SALDOFINAL = SALDOFINAL

                if (family) {
                    const test = await EvoluiSaldoRepository.GetVerificaSaldo(family, false, connectionKey)
                    if (!test) {
                        await EvoluiSaldoRepository.InsertSaldoCons(family, false, connectionKey)
                    } else {
                        family.NRORG = params.NRORG
                        await EvoluiSaldoRepository.AtualizaSaldoCons(family, false, connectionKey)
                    }
                }
            }
        }
        console.log('verificação de saldo concluída')
    }
}

const CalculoSaldo = async function (params, family) {
    if (params.IDTPMOVEXT === 'C') {
        params.SALDOFINAL = Math.round((parseFloat(family.VRSALDCONEXT || 0) + parseFloat(params.VRMOVEXTCONS)) * 100) / 100
    } else {
        params.SALDOFINAL = Math.round((parseFloat(family.VRSALDCONEXT || 0) - parseFloat(params.VRMOVEXTCONS)) * 100) / 100
    }
    return params
}

const CalculoSaldoFinal = async function (params) {
    if (params.IDTPMOVEXT === 'C') {
        params.SALDOFINAL = Math.round((parseFloat(params.SALDOFINAL) + parseFloat(params.VRMOVEXTCONS)) * 100) / 100
    } else {
        params.SALDOFINAL = Math.round((parseFloat(params.SALDOFINAL) - parseFloat(params.VRMOVEXTCONS)) * 100) / 100
    }

    return params
}

export default { EvoluiSaldoFunction }