import ValueRestrictionRepository from '../Repositories/ValueRestrictionRepository.js'

const getValueRestrictions = async function ({ CDCONSUMIDOR, consDetails }) {
    const result = await ValueRestrictionRepository.getValueRestrictions(consDetails, CDCONSUMIDOR)

    return result
}

const updateValueRestriction = async function ({ CDCONSUMIDOR, CDFAMILISALD, VRCONSDIARAL, consDetails }) {
    const result = await ValueRestrictionRepository.updateValueRestriction(CDCONSUMIDOR, CDFAMILISALD, VRCONSDIARAL, consDetails)

    return result
}

const getUnrestrictedFamilies = async function ({ CDCONSUMIDOR, consDetails }) {
    const result = await ValueRestrictionRepository.getUnrestrictedFamilies(CDCONSUMIDOR, consDetails)
    
    return result
}

const getValueRestriction = async function ({ CDCONSUMIDOR, CDFAMILISALD, consDetails }) {
    const result = await ValueRestrictionRepository.getValueRestriction(CDCONSUMIDOR, CDFAMILISALD, consDetails)

    return result
}

const addValueRestriction = async function ({ CDCONSUMIDOR, CDFAMILISALD, VRCONSDIARAL, consDetails }) {
    const valueRestriction = await getValueRestriction({ CDCONSUMIDOR, CDFAMILISALD, consDetails })
    var result
    if (valueRestriction.length == 0) {
        result = await ValueRestrictionRepository.addValueRestriction(CDCONSUMIDOR, CDFAMILISALD, VRCONSDIARAL, consDetails)
    } else {
        result = await ValueRestrictionRepository.updateValueRestriction(CDCONSUMIDOR, CDFAMILISALD, VRCONSDIARAL, consDetails)
    }

    return result
}

const deleteValueRestriction = async function ({ CDCONSUMIDOR, CDFAMILISALD, consDetails }) {
    /* Validate if there are any restricted products in the selected family. */
    const restrictedProducts = await ValueRestrictionRepository.getRestrictedProducts(CDCONSUMIDOR, CDFAMILISALD, consDetails)

    var result
    if (restrictedProducts.length == 0) {
        /* No restricted products found in the family. */
        result = await ValueRestrictionRepository.deleteValueRestriction(CDCONSUMIDOR, CDFAMILISALD, consDetails)
    } else {
        /* Restricted products were found, therefore we can't delete the value restriction. So we will update to zero! */
        result = await ValueRestrictionRepository.updateValueRestriction(CDCONSUMIDOR, CDFAMILISALD, 0, consDetails)
    }
    
    return result
}

export default { getValueRestrictions, updateValueRestriction, getUnrestrictedFamilies, getValueRestriction, addValueRestriction, deleteValueRestriction }