import { executeQuery } from '../Connection/QueriesExecutor.js'

const checkBalance = async function (params, autoCommit = true, connectionKey) {
    const result = await executeQuery({
        sql: 'CHECK_BALANCE',
        binds: { ...params },
        rawReturn: true,
        autoCommit: autoCommit,
        connectionKey
    })

    return result
}

const createBalance = async function (params, autoCommit = true, connectionKey) {
    const result = await executeQuery({
        sql: 'CREATE_BALANCE',
        binds: { ...params },
        rawReturn: true,
        autoCommit: autoCommit,
        connectionKey
    })

    return result
}

const updateBalance = async function (params, autoCommit = true, connectionKey) {
    const result = await executeQuery({
        sql: 'UPDATE_BALANCE',
        binds: { ...params },
        rawReturn: true,
        autoCommit: autoCommit,
        connectionKey
    })

    return result
}

const getBonusRecharge = async function (params, autoCommit = true, connectionKey) {
    const result = await executeQuery({
        sql: 'GET_BONUS_RECHARGE_ORIGIN',
        binds: { ...params },
        rawReturn: true,
        autoCommit: autoCommit,
        connectionKey
    })

    return result
}

export default { checkBalance, createBalance, updateBalance, getBonusRecharge }