import { executeQuery } from '../Connection/QueriesExecutor.js'

const getAppBalance = async function (consDetails, CDCONSUMIDOR) {
    const result = await executeQuery({sql: 'GET_BALANCE_EXTRACT',
        binds: {
            CDCLIENTE: consDetails.CDCLIENTE,
            CDCONSUMIDOR: CDCONSUMIDOR,
            CDFILIAL: consDetails.CDFILIAL
        },
        rawReturn: true
    })
    return result
}

const getExtract = async function (consDetails, CDCONSUMIDOR, DTINI, DTFIM) {
    const result = await executeQuery({sql: 'GET_EXTRACT', 
        binds: {
            "P_CDCLIENTE": consDetails.CDCLIENTE,
            "P_CDCONSUMIDOR": CDCONSUMIDOR,
            // "P_DTEXTRATOINI": "01/12/2022",
            // "P_DTEXTRATOFIN": "31/12/2022"
            "P_DTEXTRATOINI": DTINI,
            "P_DTEXTRATOFIN": DTFIM
        },
        rawReturn: true
    })
    return result
}

const getFullBalance = async function (consDetails) {
    const result = await executeQuery({sql: 'GET_FULL_BALANCE',
        binds: {
            CDCLIENTE: consDetails.CDCLIENTE,
            CDFILIAL: consDetails.CDFILIAL,
            NRCPFRESPCON: consDetails.NRCPFRESPCON
        },
        rawReturn: true
    })
    return result
}

export default { getAppBalance, getExtract, getFullBalance }
